inherit GTK2.TreeView;

object model;
object selection;

void create(mixed ... args) {
  ::create(@args);
  model=get_model();
  selection=get_selection();
}

object create_model(array types) {
  model=GTK2.ListStore(
	predef::map(types,lambda(mapping b) { return b->type; })
  );
  set_model(model);
  int i=0;
  object cell,col;
  foreach (types, mapping b) {
    switch (b->type) {
      case "string":
	cell=GTK2.CellRendererText();
	col=GTK2.TreeViewColumn(b->name,cell,"text",i);
	break;
      case "active":
	cell=GTK2.CellRendererToggle();
	col=GTK2.TreeViewColumn(b->name,cell,"active",i);
	break;
      case "stock-id":
	cell=GTK2.CellRendererPixbuf();
	col=GTK2.TreeViewColumn(b->name,cell,"text",i);
	break;
      case "GdkPixbuf":
	cell=GTK2.CellRendererPixbuf();
	col=GTK2.TreeViewColumn(b->name,cell,"pixbuf",i);
	break;
    }
    if (has_index(b,"visible"))
      col->set_visible(b->visible);
    append_column(col);
    i++;
  }
  return this_object();
}

object append_row(mixed ... args) {
  object iter=model->append();
  set_row(iter,@args);
  return iter;
}

object prepend_row(mixed ... args) {
  object iter=model->prepend();
  set_row(iter,@args);
  return iter;
}

#define W(X) mixed X(mixed ... args) { return model->X(@args); }

W(get_iter_first)
W(get_iter)
W(iter_next)
W(get_n_columns)
W(get_value)
W(set_row)

array get_selected() {
  return selection->get_selected();
}

void select_iter(mixed ... args) {
  selection->select_iter(@args);
}
