#!/usr/bin/env pike

int main(int argc, array argv) {
  GTK2.setup_gtk();
  object w=GTK2.Window(GTK2.WINDOW_TOPLEVEL);
  w->set_size_request(300,300);
  w->set_title("GtkDatabox: Basics");
  w->set_border_width(0);
  object box1=GTK2.Vbox(0,0);
  w->add(box1);
  object label=GTK2.Label("Draw a selection with the left button pressed,\n"
	"Then click into the selection.\n"
	"Use the right mouse button to zoom out.\n"
	"Shift+mouse button zooms to default.");
  box1->pack_start(label,0,0,0);
  object separator=GTK2.Hseparator();
  box1->pack_start(separator,0,0,0);
  object box=GTK2.Databox();
  box->set_background_color(GDK2.Color(16383,16383,16383));
  array x,y;
  x=allocate(2000);
  y=allocate(2000);
  for (int i=0; i<2000; i++) {
    x[i]=i;
    y[i]=100.0*sin(i*2*Math.pi/2000);
  }
  int index=box->data_add(2000,x,y,GDK2.Color(0,65535,0),GTK2.DATABOX_POINTS,1);
  array y1;
  y1=allocate(2000);
  for (int i=0; i<2000; i++) {
    y1[i]=100.0*cos(i*2*Math.pi/2000);
  }
  box->data_add(2000,x,y1,GDK2.Color(65535,0,0),GTK2.DATABOX_POINTS,1);
  box->rescale_inverted(1,1);
  box1->pack_start(box,1,1,0);
  separator=GTK2.Hseparator();
  box1->pack_start(separator,0,1,0);
  object box2=GTK2.Vbox(0,10);
  box2->set_border_width(10);
  box1->pack_end(box2,0,1,0);
  object close_button=GTK2.Button("close");
  close_button->signal_connect("clicked",lambda(){ exit(0); },0);
  box2->pack_start(close_button,1,1,0);
  close_button->set_flags(GTK2.CAN_DEFAULT);
  close_button->grab_default();

  w->show_all();
  w->signal_connect("destroy",lambda(){ exit(0); },0);
  return -1;
}

